Index: main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/tests/test_browser.py
===================================================================
--- main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/tests/test_browser.py	(revision 15680)
+++ main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/tests/test_browser.py	(revision 15747)
@@ -74,7 +74,7 @@
         self.assertEqual(self.student['payments'].values()[0].p_category, 'schoolfee_1')
         self.assertEqual(self.student['payments'].values()[1].p_category, 'schoolfee_2')
-        # 79200 / 2 + 250
-        self.assertEqual(self.student['payments'].values()[0].amount_auth, 39850.0)
-        self.assertEqual(self.student['payments'].values()[1].amount_auth, 39850.0)
+        # 80200 / 2 + 250
+        self.assertEqual(self.student['payments'].values()[0].amount_auth, 40350.0)
+        self.assertEqual(self.student['payments'].values()[1].amount_auth, 40350.0)
         # The  two payments belong to the same session and level.
         self.assertEqual(self.student['payments'].values()[0].p_session, 2004)
@@ -104,7 +104,7 @@
         self.assertEqual(self.student.current_level, 200)
         self.assertEqual(self.student.current_session, 2005)
-        # 63100 / 2 + 250
-        self.assertEqual(self.student['payments'].values()[2].amount_auth, 37600.0)
-        self.assertEqual(self.student['payments'].values()[3].amount_auth, 37600.0)
+        # 73700 / 2 + 250
+        self.assertEqual(self.student['payments'].values()[2].amount_auth, 37100.0)
+        self.assertEqual(self.student['payments'].values()[3].amount_auth, 37100.0)
         # The last two payments belong to the same session and level.
         self.assertEqual(self.student['payments'].values()[2].p_session, 2005)
Index: main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/tests/test_export.py
===================================================================
--- main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/tests/test_export.py	(revision 15680)
+++ main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/tests/test_export.py	(revision 15747)
@@ -103,10 +103,10 @@
         result = open(self.outfile, 'rb').read()
         self.assertMatches(
-            'ac,amount_auth,creation_date,gateway_amt,p_category,p_combi,p_current,'
+            'ac,amount_auth,creation_date,gateway_amt,net_amt,p_category,p_combi,p_current,'
             'p_id,p_item,p_level,p_session,p_state,payment_date,provider_amt,'
             'r_amount_approved,r_card_num,r_code,r_company,r_desc,'
             'r_pay_reference,thirdparty_amt,student_id,state,'
             'current_session\r\n'
-            '666,12.12,%s-04-01 13:12:01#,,schoolfee,[],1,my-id,p-item,'
+            '666,12.12,%s-04-01 13:12:01#,,,schoolfee,[],1,my-id,p-item,'
             '100,%s,paid,%s-04-01 14:12:01#,,12.12,'
             '789,r-code,interswatch,,,,A111111,created,2012\r\n'
Index: main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/tests/test_utils.py
===================================================================
--- main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/tests/test_utils.py	(revision 15680)
+++ main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/tests/test_utils.py	(revision 15747)
@@ -31,5 +31,5 @@
         self.assertEqual(payment.p_level, 100)
         self.assertEqual(payment.p_session, 2016)
-        self.assertEqual(payment.amount_auth, 79450.0)
+        self.assertEqual(payment.amount_auth, 80450.0)
         self.assertEqual(payment.p_item, u'CERT1')
         self.assertEqual(error, None)
@@ -38,5 +38,5 @@
         self.assertEqual(payment.p_level, 100)
         self.assertEqual(payment.p_session, 2016)
-        self.assertEqual(payment.amount_auth, 39850.0)
+        self.assertEqual(payment.amount_auth, 40350.0)
         self.assertEqual(payment.p_item, u'CERT1')
         self.assertEqual(error, None)
@@ -45,5 +45,5 @@
         self.assertEqual(payment.p_level, 100)
         self.assertEqual(payment.p_session, 2016)
-        self.assertEqual(payment.amount_auth, 39850.0)
+        self.assertEqual(payment.amount_auth, 40350.0)
         self.assertEqual(payment.p_item, u'CERT1')
         self.assertEqual(error, None)
@@ -55,5 +55,5 @@
         self.student.lga = 'delta_burutu'
         error, payment = utils.setPaymentDetails('schoolfee',self.student)
-        self.assertEqual(payment.amount_auth, 69450.0)
+        self.assertEqual(payment.amount_auth, 70450.0)
         error, payment = utils.setPaymentDetails('clearance',self.student)
         self.assertEqual(payment.amount_auth, 20300.0)
Index: main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/utils.py
===================================================================
--- main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/utils.py	(revision 15680)
+++ main/kofacustom.coewarri/trunk/src/kofacustom/coewarri/students/utils.py	(revision 15747)
@@ -43,14 +43,14 @@
 FEES_VALUES = (
       ( # 100      110      200      210      300      310      400      410     500  999
-        (42200.0, 42200.0, 39700.0, 39700.0, 37200.0, 37200.0, 0.0, 0.0, 0.0, 0.0), # nce_ft
-        (55200.0, 55200.0, 49200.0, 49200.0, 52200.0, 52200.0, 42200.0, 42200.0, 0.0, 0.0), # nce_pt
-        (69200.0, 69200.0, 64700.0, 64700.0, 67700.0, 67700.0, 62100.0, 62100.0, 0.0, 0.0), # ug_ft
-        (33000.0, 33000.0, 28000.0, 28000.0, 28000.0, 28000.0, 20000.0, 20000.0, 0.0, 0.0), # nce_we_pt
+        (43200.0, 43200.0, 42700.0, 42700.0, 37200.0, 37200.0, 0.0, 0.0, 0.0, 0.0), # nce_ft
+        (55200.0, 55200.0, 49200.0, 49200.0, 53200.0, 53200.0, 49200.0, 49200.0, 0.0, 0.0), # nce_pt
+        (70200.0, 70200.0, 63700.0, 63700.0, 70700.0, 70700.0, 61700.0, 61700.0, 0.0, 0.0), # ug_ft
+        (33200.0, 33200.0, 28000.0, 28000.0, 32000.0, 32000.0, 28000.0, 28000.0, 0.0, 0.0), # nce_we_pt
       ), # local
       ( #
-        (54800.0, 54800.0, 52300.0, 52300.0, 49800.0, 49800.0, 0.0, 0.0, 0.0, 0.0), # nce_ft
-        (55200.0, 55200.0, 49200.0, 49200.0, 52200.0, 52200.0, 42200.0, 42200.0, 0.0, 0.0), # nce_pt
-        (79200.0, 79200.0, 74700.0, 74700.0, 77700.0, 77700.0, 62100.0, 62100.0, 0.0, 0.0), # ug_ft
-        (33000.0, 33000.0, 28000.0, 28000.0, 28000.0, 28000.0, 20000.0, 20000.0, 0.0, 0.0), # nce_we_pt
+        (55800.0, 55800.0, 54800.0, 54800.0, 49800.0, 49800.0, 0.0, 0.0, 0.0, 0.0), # nce_ft
+        (55200.0, 55200.0, 49200.0, 49200.0, 53200.0, 53200.0, 49200.0, 49200.0, 0.0, 0.0), # nce_pt
+        (80200.0, 80200.0, 73700.0, 73700.0, 80700.0, 80700.0, 71700.0, 71700.0, 0.0, 0.0), # ug_ft
+        (33200.0, 33200.0, 28000.0, 28000.0, 32000.0, 32000.0, 28000.0, 28000.0, 0.0, 0.0), # nce_we_pt
       ), # non-local
     )