Index: main/kofacustom.dspg/trunk/src/kofacustom/dspg/students/browser.py
===================================================================
--- main/kofacustom.dspg/trunk/src/kofacustom/dspg/students/browser.py	(revision 15750)
+++ main/kofacustom.dspg/trunk/src/kofacustom/dspg/students/browser.py	(revision 15751)
@@ -247,29 +247,31 @@
     @property
     def post_text(self):
-        return """1. 	This offer is conditional upon the confirmation of your qualification(s) as listed by you in the application form or which you claim to possess as at when this offer of admission was made and your meeting the minimum department entry requirement.
-
-2. At the time of Registration, you will be required to produce the original copies of your certificates or any other acceptable evidence of the qualification(s), on which this offer of admission has been based.
-
-3. If at any time after admission it is discovered that you do not possess any of the qualifications which you claimed to have obtained, you will be required to withdraw from the Polytechnic.
-
-4. Please, note that resumption/registration starts immediately.
-
-5. You are required to pay all the necessary fees, such as school fees, students\' union fees, boarding fees (optional) and any other prescribed fees online and register immediately. Late registration will attract severe sanction such as payment of late registration fee of N10000 or outright withdrawal of offer of admission.
-
-6. If you do not respond to this offer within two (2) weeks from the date of resumption, the Polytechnic will assume that you are not interested in the offer and may withdraw the offer to accommodate other candidates on awaiting list.
-
-7. If you do not pay your school fees and register within the stipulated time frame for registration, you would not be allowed to write the Polytechnic\'s semester examinations. Should you mistakenly write the exams, your scripts would not be marked.
-
-8. You are required to present at the time of registration, a letter of attestation from a clergy man, a lawyer,  a senior civil servant (Level 13 and above) or any person of reputable standing in the society.
-
-9. Before the commencement of registration, you will be required to undergo a medical examination which should be conducted in the Polytechnic clinic.
-
-10. Other information/instructions about facilities at the Polytechnic, including accommodation, can be obtained from the Polytechnic Portal. The Head of your School/Department at the Polytechnic will make the details of the programme available to you.
-
-11. At the time of registration, you are required to sign an undertaking of non-involvement in cult-related activities and acts of vandalism.
-
-12. We hope that you will be able to take advantage of this offer or provisional admission.
-
-13. Please, accept our hearty congratulations.
+        return """1. Duration: 2 years
+
+2. 	This offer is conditional upon the confirmation of your qualification(s) as listed by you in the application form or which you claim to possess as at when this offer of admission was made and your meeting the minimum department entry requirement.
+
+3. At the time of Registration, you will be required to produce the original copies of your certificates or any other acceptable evidence of the qualification(s), on which this offer of admission has been based.
+
+4. If at any time after admission it is discovered that you do not possess any of the qualifications which you claimed to have obtained, you will be required to withdraw from the Polytechnic.
+
+5. Please, note that resumption/registration starts immediately.
+
+6. You are required to pay all the necessary fees, such as school fees, students\' union fees, boarding fees (optional) and any other prescribed fees online and register immediately. Late registration will attract severe sanction such as payment of late registration fee of N10000 or outright withdrawal of offer of admission.
+
+7. If you do not respond to this offer within two (2) weeks from the date of resumption, the Polytechnic will assume that you are not interested in the offer and may withdraw the offer to accommodate other candidates on awaiting list.
+
+8. If you do not pay your school fees and register within the stipulated time frame for registration, you would not be allowed to write the Polytechnic\'s semester examinations. Should you mistakenly write the exams, your scripts would not be marked.
+
+9. You are required to present at the time of registration, a letter of attestation from a clergy man, a lawyer,  a senior civil servant (Level 13 and above) or any person of reputable standing in the society.
+
+10. Before the commencement of registration, you will be required to undergo a medical examination which should be conducted in the Polytechnic clinic.
+
+11. Other information/instructions about facilities at the Polytechnic, including accommodation, can be obtained from the Polytechnic Portal. The Head of your School/Department at the Polytechnic will make the details of the programme available to you.
+
+12. At the time of registration, you are required to sign an undertaking of non-involvement in cult-related activities and acts of vandalism.
+
+13. We hope that you will be able to take advantage of this offer or provisional admission.
+
+14. Please, accept our hearty congratulations.
 
 Admissions Officer
Index: main/kofacustom.dspg/trunk/src/kofacustom/dspg/students/tests/test_export.py
===================================================================
--- main/kofacustom.dspg/trunk/src/kofacustom/dspg/students/tests/test_export.py	(revision 15750)
+++ main/kofacustom.dspg/trunk/src/kofacustom/dspg/students/tests/test_export.py	(revision 15751)
@@ -103,10 +103,10 @@
         result = open(self.outfile, 'rb').read()
         self.assertMatches(
-            'ac,amount_auth,creation_date,gateway_amt,p_category,p_combi,p_current,'
+            'ac,amount_auth,creation_date,gateway_amt,net_amt,p_category,p_combi,p_current,'
             'p_id,p_item,p_level,p_session,p_state,payment_date,provider_amt,'
             'r_amount_approved,r_card_num,r_code,r_company,r_desc,'
             'r_pay_reference,thirdparty_amt,student_id,state,'
             'current_session\r\n'
-            '666,12.12,%s-04-01 13:12:01#,,schoolfee,[],1,my-id,p-item,'
+            '666,12.12,%s-04-01 13:12:01#,,,schoolfee,[],1,my-id,p-item,'
             '100,%s,paid,%s-04-01 14:12:01#,,12.12,'
             '789,r-code,interswatch,,,,A111111,created,2012\r\n'