Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/applicantsbrowser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/applicantsbrowser.py	(revision 15769)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/applicantsbrowser.py	(revision 15770)
@@ -42,5 +42,5 @@
     try:
         return getattr(grok.getSite()['configuration'][str(session)],
-            'etranzact_payoutlet_enabled', False)
+            'etranzact_webconnect_enabled', False)
     except KeyError:
         return False
@@ -58,5 +58,5 @@
     def target_url(self):
         if not module_activated(
-            self.context.student.current_session, self.context):
+            self.context.__parent__.__parent__.year, self.context):
             return ''
         if self.context.p_state != 'unpaid':
@@ -76,5 +76,5 @@
     def target_url(self):
         if not module_activated(
-            self.context.student.current_session, self.context):
+            self.context.__parent__.__parent__.year, self.context):
             return ''
         if self.context.p_state in ('paid', 'waived'):
@@ -107,5 +107,5 @@
     def init_update(self):
         if not module_activated(
-            self.context.student.current_session, self.context):
+            self.context.__parent__.__parent__.year, self.context):
             return _("Etranzact payments deactivated.")
         if self.context.p_state == 'paid':
@@ -158,5 +158,5 @@
         super(EtranzactReceiveResponseApplicant, self).update()
         if not module_activated(
-            self.context.student.current_session, self.context):
+            self.context.__parent__.__parent__.year, self.context):
             return
         applicant = self.context.__parent__
@@ -192,5 +192,5 @@
     def update(self):
         if not module_activated(
-            self.context.student.current_session, self.context):
+            self.context.__parent__.__parent__.year, self.context):
             return
         if self.context.p_state in ('paid', 'waived'):
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/payoutletbrowser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/payoutletbrowser.py	(revision 15769)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/payoutletbrowser.py	(revision 15770)
@@ -44,5 +44,7 @@
 grok.templatedir('browser_templates')
 
-def module_activated(session):
+def module_activated(session, payment):
+    if payment.r_company and payment.r_company != 'etranzact':
+        return False
     try:
         return getattr(grok.getSite()['configuration'][str(session)],
@@ -61,5 +63,6 @@
     @property
     def target_url(self):
-        if not module_activated(self.context.__parent__.__parent__.year):
+        if not module_activated(
+            self.context.__parent__.__parent__.year, self.context):
             return ''
         if self.context.p_state in ('paid', 'waived'):
@@ -77,5 +80,6 @@
     @property
     def target_url(self):
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return ''
         if self.context.p_state in ('paid', 'waived'):
@@ -98,8 +102,7 @@
 
     def update(self):
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return
-        if self.context.r_company and self.context.r_company != 'etranzact':
-            return _("Payment ticket has been used for another payment gateway.")
         super(EtranzactEnterPinPageStudent, self).update()
         # Already now it becomes an Etranzact payment. We set the net amount
@@ -129,5 +132,6 @@
 
     def update(self, confirmation_number=None):
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return
         if self.context.p_state == 'paid':
@@ -163,5 +167,6 @@
 
     def update(self, confirmation_number=None):
-        if not module_activated(self.context.__parent__.__parent__.year):
+        if not module_activated(
+            self.context.__parent__.__parent__.year, self.context):
             return
         if self.context.p_state == 'paid':
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/studentsbrowser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/studentsbrowser.py	(revision 15769)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/studentsbrowser.py	(revision 15770)
@@ -37,5 +37,7 @@
 grok.templatedir('browser_templates')
 
-def module_activated(session):
+def module_activated(session, payment):
+    if payment.r_company and payment.r_company != 'etranzact':
+        return False
     try:
         return getattr(grok.getSite()['configuration'][str(session)],
@@ -55,5 +57,6 @@
     @property
     def target_url(self):
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return ''
         if self.context.p_state != 'unpaid':
@@ -72,5 +75,6 @@
     @property
     def target_url(self):
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return ''
         if self.context.p_state in ('paid', 'waived'):
@@ -102,5 +106,6 @@
 
     def init_update(self):
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return _("Etranzact payments deactivated.")
         if self.context.p_state == 'paid':
@@ -152,5 +157,6 @@
     def update(self):
         super(EtranzactReceiveResponseStudent, self).update()
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return
         student = self.context.student
@@ -185,5 +191,6 @@
 
     def update(self):
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return
         if self.context.p_state in ('paid', 'waived'):
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/interswitch/browser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/interswitch/browser.py	(revision 15769)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/interswitch/browser.py	(revision 15770)
@@ -38,5 +38,7 @@
 # Buttons
 
-def module_activated(session):
+def module_activated(session, payment):
+    if payment.r_company and payment.r_company != 'interswitch':
+        return False
     try:
         return getattr(grok.getSite()['configuration'][str(session)],
@@ -56,5 +58,6 @@
     @property
     def target_url(self):
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return ''
         if self.context.p_state != 'unpaid':
@@ -68,5 +71,6 @@
     @property
     def target_url(self):
-        if not module_activated(self.context.__parent__.__parent__.year):
+        if not module_activated(
+            self.context.__parent__.__parent__.year, self.context):
             return ''
         if self.context.p_state != 'unpaid':
@@ -85,5 +89,6 @@
     @property
     def target_url(self):
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return ''
         if self.context.p_state in ('paid', 'waived'):
@@ -98,5 +103,6 @@
     @property
     def target_url(self):
-        if not module_activated(self.context.__parent__.__parent__.year):
+        if not module_activated(
+            self.context.__parent__.__parent__.year, self.context):
             return ''
         if self.context.p_state in ('paid', 'waived'):
@@ -115,5 +121,6 @@
     @property
     def target_url(self):
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return ''
         if self.context.p_state != 'paid' \
@@ -129,5 +136,6 @@
     @property
     def target_url(self):
-        if not module_activated(self.context.__parent__.__parent__.year):
+        if not module_activated(
+            self.context.__parent__.__parent__.year, self.context):
             return ''
         if self.context.p_state != 'paid' \
@@ -152,5 +160,6 @@
 
     def update(self):
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return
         if self.context.p_state in ('paid', 'waived'):
@@ -191,5 +200,6 @@
 
     def update(self):
-        if not module_activated(self.context.__parent__.__parent__.year):
+        if not module_activated(
+            self.context.__parent__.__parent__.year, self.context):
             return
         if self.context.p_state == 'paid':
@@ -230,5 +240,6 @@
 
     def update(self):
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return
         if self.context.p_state  != 'paid' \
@@ -266,5 +277,6 @@
 
     def update(self):
-        if not module_activated(self.context.__parent__.__parent__.year):
+        if not module_activated(
+            self.context.__parent__.__parent__.year, self.context):
             return
         if self.context.p_state != 'paid' \
@@ -348,5 +360,6 @@
 
     def update(self):
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return
         error = self.init_update()
@@ -406,5 +419,6 @@
 
     def update(self):
-        if not module_activated(self.context.__parent__.__parent__.year):
+        if not module_activated(
+            self.context.__parent__.__parent__.year, self.context):
             return
         error = self.init_update()
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/interswitch/browser_templates/student_goto_interswitch.pt
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/interswitch/browser_templates/student_goto_interswitch.pt	(revision 15769)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/interswitch/browser_templates/student_goto_interswitch.pt	(revision 15770)
@@ -3,5 +3,6 @@
 
   <p i18n:translate="">
-    These data will be submitted to the CollegePAY payment gateway,
+    These data will be submitted to the CollegePAY payment gateway.
+    Gateway and portal provider fees might have been added to the total amount,
     please check:
   </p>
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/applicantsbrowser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/applicantsbrowser.py	(revision 15769)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/applicantsbrowser.py	(revision 15770)
@@ -51,5 +51,6 @@
     @property
     def target_url(self):
-        if not module_activated(self.context.__parent__.__parent__.year):
+        if not module_activated(
+            self.context.__parent__.__parent__.year, self.context):
             return ''
         if self.context.p_state != 'unpaid':
@@ -68,5 +69,6 @@
     @property
     def target_url(self):
-        if not module_activated(self.context.__parent__.__parent__.year):
+        if not module_activated(
+            self.context.__parent__.__parent__.year, self.context):
             return ''
         if self.context.p_state in ('paid', 'waived'):
@@ -85,5 +87,6 @@
     @property
     def target_url(self):
-        if not module_activated(self.context.__parent__.__parent__.year):
+        if not module_activated(
+            self.context.__parent__.__parent__.year, self.context):
             return ''
         if self.context.p_state != 'paid' \
@@ -107,5 +110,6 @@
 
     def update(self):
-        if not module_activated(self.context.__parent__.__parent__.year):
+        if not module_activated(
+            self.context.__parent__.__parent__.year, self.context):
             return
         if self.context.p_state in ('paid', 'waived'):
@@ -159,5 +163,6 @@
 
     def update(self):
-        if not module_activated(self.context.__parent__.__parent__.year):
+        if not module_activated(
+            self.context.__parent__.__parent__.year, self.context):
             return
         if self.context.p_state  != 'paid' \
@@ -272,5 +277,6 @@
 
     def update(self):
-        if not module_activated(self.context.__parent__.__parent__.year):
+        if not module_activated(
+            self.context.__parent__.__parent__.year, self.context):
             return
         self.orderId = self.context.p_id
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/studentsbrowser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/studentsbrowser.py	(revision 15769)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/studentsbrowser.py	(revision 15770)
@@ -38,5 +38,7 @@
 grok.templatedir('browser_templates')
 
-def module_activated(session):
+def module_activated(session, payment):
+    if payment.r_company and payment.r_company != 'interswitch':
+        return False
     try:
         return getattr(grok.getSite()['configuration'][str(session)],
@@ -58,5 +60,6 @@
     @property
     def target_url(self):
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return ''
         if self.context.p_state != 'unpaid':
@@ -75,5 +78,6 @@
     @property
     def target_url(self):
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return ''
         if self.context.p_state in ('paid', 'waived'):
@@ -93,5 +97,6 @@
     @property
     def target_url(self):
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return ''
         if self.context.p_state != 'paid' \
@@ -115,5 +120,6 @@
 
     def update(self):
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return
         if self.context.p_state in ('paid', 'waived'):
@@ -167,5 +173,6 @@
 
     def update(self):
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return
         if self.context.p_state  != 'paid' \
@@ -289,5 +296,6 @@
 
     def update(self):
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return
         self.orderId = self.context.p_id