Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/applicantsbrowser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/applicantsbrowser.py	(revision 15771)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/applicantsbrowser.py	(revision 15772)
@@ -31,18 +31,9 @@
 from kofacustom.nigeria.applicants.interfaces import INigeriaApplicantOnlinePayment
 from kofacustom.nigeria.interfaces import MessageFactory as _
-
+from kofacustom.nigeria.etranzact.studentsbrowser import webconnect_module_activated
 from kofacustom.nigeria.etranzact.tests import (
     TERMINAL_ID, HOST, HTTPS, SECRET_KEY, LOGO_URL, GATEWAY_AMT)
 
 grok.templatedir('browser_templates')
-
-def module_activated(session, payment):
-    if payment.r_company and payment.r_company != 'etranzact':
-        return False
-    try:
-        return getattr(grok.getSite()['configuration'][str(session)],
-            'etranzact_webconnect_enabled', False)
-    except KeyError:
-        return False
 
 class EtranzactActionButtonApplicant(ManageActionButton):
@@ -57,5 +48,5 @@
     @property
     def target_url(self):
-        if not module_activated(
+        if not webconnect_module_activated(
             self.context.__parent__.__parent__.year, self.context):
             return ''
@@ -75,5 +66,5 @@
     @property
     def target_url(self):
-        if not module_activated(
+        if not webconnect_module_activated(
             self.context.__parent__.__parent__.year, self.context):
             return ''
@@ -106,7 +97,4 @@
 
     def init_update(self):
-        if not module_activated(
-            self.context.__parent__.__parent__.year, self.context):
-            return _("Etranzact payments deactivated.")
         if self.context.p_state == 'paid':
             return _("Payment ticket can't be re-sent to Etranzact.")
@@ -134,4 +122,7 @@
         # Already now it becomes an Etranzact payment. We set the net amount
         # and add the gateway amount.
+        if not webconnect_module_activated(
+            self.context.__parent__.__parent__.year, self.context):
+            return _("Etranzact payments deactivated.")
         if not self.context.r_company:
             self.context.net_amt = self.context.amount_auth
@@ -157,5 +148,5 @@
     def update(self):
         super(EtranzactReceiveResponseApplicant, self).update()
-        if not module_activated(
+        if not webconnect_module_activated(
             self.context.__parent__.__parent__.year, self.context):
             return
@@ -191,5 +182,5 @@
 
     def update(self):
-        if not module_activated(
+        if not webconnect_module_activated(
             self.context.__parent__.__parent__.year, self.context):
             return
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/payoutletbrowser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/payoutletbrowser.py	(revision 15771)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/payoutletbrowser.py	(revision 15772)
@@ -44,5 +44,5 @@
 grok.templatedir('browser_templates')
 
-def module_activated(session, payment):
+def payoutlet_module_activated(session, payment):
     if payment.r_company and payment.r_company != 'etranzact':
         return False
@@ -63,5 +63,5 @@
     @property
     def target_url(self):
-        if not module_activated(
+        if not payoutlet_module_activated(
             self.context.__parent__.__parent__.year, self.context):
             return ''
@@ -80,5 +80,5 @@
     @property
     def target_url(self):
-        if not module_activated(
+        if not payoutlet_module_activated(
             self.context.student.current_session, self.context):
             return ''
@@ -102,5 +102,5 @@
 
     def update(self):
-        if not module_activated(
+        if not payoutlet_module_activated(
             self.context.student.current_session, self.context):
             return
@@ -124,5 +124,5 @@
 
     def update(self):
-        if not module_activated(
+        if not payoutlet_module_activated(
             self.context.__parent__.__parent__.year, self.context):
             return
@@ -148,5 +148,5 @@
 
     def update(self, confirmation_number=None):
-        if not module_activated(
+        if not payoutlet_module_activated(
             self.context.student.current_session, self.context):
             return
@@ -183,5 +183,5 @@
 
     def update(self, confirmation_number=None):
-        if not module_activated(
+        if not payoutlet_module_activated(
             self.context.__parent__.__parent__.year, self.context):
             return
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/studentsbrowser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/studentsbrowser.py	(revision 15771)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/studentsbrowser.py	(revision 15772)
@@ -37,5 +37,5 @@
 grok.templatedir('browser_templates')
 
-def module_activated(session, payment):
+def webconnect_module_activated(session, payment):
     if payment.r_company and payment.r_company != 'etranzact':
         return False
@@ -57,5 +57,5 @@
     @property
     def target_url(self):
-        if not module_activated(
+        if not webconnect_module_activated(
             self.context.student.current_session, self.context):
             return ''
@@ -75,5 +75,5 @@
     @property
     def target_url(self):
-        if not module_activated(
+        if not webconnect_module_activated(
             self.context.student.current_session, self.context):
             return ''
@@ -106,7 +106,4 @@
 
     def init_update(self):
-        if not module_activated(
-            self.context.student.current_session, self.context):
-            return _("Etranzact payments deactivated.")
         if self.context.p_state == 'paid':
             return _("Payment ticket can't be re-sent to Etranzact.")
@@ -134,4 +131,7 @@
         # Already now it becomes an Etranzact payment. We set the net amount
         # and add the gateway amount.
+        if not webconnect_module_activated(
+            self.context.student.current_session, self.context):
+            return _("Etranzact payments deactivated.")
         if not self.context.r_company:
             self.context.net_amt = self.context.amount_auth
@@ -157,5 +157,5 @@
     def update(self):
         super(EtranzactReceiveResponseStudent, self).update()
-        if not module_activated(
+        if not webconnect_module_activated(
             self.context.student.current_session, self.context):
             return
@@ -191,5 +191,5 @@
 
     def update(self):
-        if not module_activated(
+        if not webconnect_module_activated(
             self.context.student.current_session, self.context):
             return