Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/applicants/browser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/applicants/browser.py	(revision 15795)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/applicants/browser.py	(revision 15796)
@@ -31,5 +31,5 @@
     )
 from waeup.kofa.applicants.viewlets import (
-    PDFActionButton)
+    PDFActionButton, PaymentReceiptActionButton)
 from waeup.kofa.applicants.pdf import PDFApplicationSlip
 from kofacustom.nigeria.applicants.interfaces import (
@@ -61,4 +61,12 @@
         return _('Download application slip')
 
+class PaymentReceiptActionButton(PaymentReceiptActionButton):
+
+    @property
+    def target_url(self):
+        if not self.context.r_company:
+            return ''
+        return self.view.url(self.view.context, self.target)
+
 class NigeriaApplicantDisplayFormPage(ApplicantDisplayFormPage):
     """A display view for applicant data.
@@ -178,4 +186,14 @@
     form_fields['payment_date'].custom_widget = FriendlyDatetimeDisplayWidget('le')
 
+    @property
+    def payment_slip_download_warning(self):
+        return ''
+
+    def update(self):
+        if not self.context.r_company:
+            self.redirect(self.url(self.context))
+            return
+        return
+
 class NigeriaApplicantRegistrationPage(ApplicantRegistrationPage):
     """Captcha'd registration page for applicants.
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/applicantsbrowser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/applicantsbrowser.py	(revision 15795)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/applicantsbrowser.py	(revision 15796)
@@ -43,5 +43,5 @@
     grok.require('waeup.payApplicant')
     icon = 'actionicon_pay.png'
-    text = _('Pay via Etranzact')
+    text = _('Pay via Etranzact WebConnect')
     target = 'goto_etranzact'
 
@@ -61,5 +61,5 @@
     grok.require('waeup.payApplicant')
     icon = 'actionicon_call.png'
-    text = _('Requery Etranzact History')
+    text = _('Requery Etranzact WebConnect History')
     target = 'requery_history'
 
@@ -69,5 +69,5 @@
             self.context.__parent__.__parent__.year, self.context):
             return ''
-        if self.context.p_state in ('paid', 'waived'):
+        if self.context.p_state in ('paid', 'waived', 'scholarship'):
             return ''
         return self.view.url(self.view.context, self.target)
@@ -185,5 +185,5 @@
             self.context.__parent__.__parent__.year, self.context):
             return
-        if self.context.p_state in ('paid', 'waived'):
+        if self.context.p_state in ('paid', 'waived', 'scholarship'):
             self.flash(_('This ticket has already been paid.'), type='danger')
             return
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/payoutletbrowser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/payoutletbrowser.py	(revision 15795)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/payoutletbrowser.py	(revision 15796)
@@ -31,4 +31,6 @@
 from waeup.kofa.students.viewlets import ApprovePaymentActionButton as APABStudent
 from waeup.kofa.applicants.viewlets import ApprovePaymentActionButton as APABApplicant
+from waeup.kofa.students.viewlets import PaymentReceiptActionButton as PRABStudent
+from waeup.kofa.applicants.viewlets import PaymentReceiptActionButton as PRABApplicant
 from kofacustom.nigeria.interswitch.browser import (
     InterswitchActionButtonStudent,
@@ -57,6 +59,6 @@
     grok.require('waeup.payApplicant')
     grok.order(3)
-    icon = 'actionicon_call.png'
-    text = _('Enter Etranzact PIN')
+    icon = 'actionicon_pay.png'
+    text = _('Pay via Etranzact PayOutlet')
     target = 'enterpin'
 
@@ -66,5 +68,5 @@
             self.context.__parent__.__parent__.year, self.context):
             return ''
-        if self.context.p_state in ('paid', 'waived'):
+        if self.context.p_state in ('paid', 'waived', 'scholarship'):
             return ''
         return self.view.url(self.view.context, self.target)
@@ -74,6 +76,6 @@
     grok.require('waeup.payStudent')
     grok.order(3)
-    icon = 'actionicon_call.png'
-    text = _('Enter Etranzact PIN')
+    icon = 'actionicon_pay.png'
+    text = _('Pay via Etranzact PayOutlet')
     target = 'enterpin'
 
@@ -83,5 +85,5 @@
             self.context.student.current_session, self.context):
             return ''
-        if self.context.p_state in ('paid', 'waived'):
+        if self.context.p_state in ('paid', 'waived', 'scholarship'):
             return ''
         return self.view.url(self.view.context, self.target)
@@ -96,5 +98,5 @@
 
     buttonname = _('Submit to Etranzact')
-    label = _('Requery Etranzact History')
+    label = _('Requery Etranzact PayOutlet History')
     action = 'query_payoutlet_history'
     placeholder = _('Confirmation Number (PIN)')
@@ -123,9 +125,15 @@
     grok.template('enterpin')
 
+    buttonname = _('Submit to Etranzact')
+    label = _('Requery Etranzact PayOutlet History')
+    action = 'query_payoutlet_history'
+    placeholder = _('Confirmation Number (PIN)')
+    gateway_amt = GATEWAY_AMT
+
     def update(self):
         if not payoutlet_module_activated(
             self.context.__parent__.__parent__.year, self.context):
             return
-        super(EtranzactEnterPinPageStudent, self).update()
+        super(EtranzactEnterPinPageApplicant, self).update()
         # Already now it becomes an Etranzact payment. We set the net amount
         # and add the gateway amount.
@@ -136,4 +144,24 @@
             self.context.r_company = u'etranzact'
         return
+
+class PayoutletPaymentReceiptActionButtonApplicant(PRABApplicant):
+
+    grok.view(EtranzactEnterPinPageApplicant)
+
+    @property
+    def target_url(self):
+        if not self.context.r_company:
+            return ''
+        return self.view.url(self.view.context, self.target)
+
+class PayoutletPaymentReceiptActionButtonStudent(PRABStudent):
+
+    grok.view(EtranzactEnterPinPageStudent)
+
+    @property
+    def target_url(self):
+        if not self.context.r_company:
+            return ''
+        return self.view.url(self.view.context, self.target)
 
 class EtranzactQueryHistoryPageStudent(UtilityView, grok.View):
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/studentsbrowser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/studentsbrowser.py	(revision 15795)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/etranzact/studentsbrowser.py	(revision 15796)
@@ -52,5 +52,5 @@
     grok.require('waeup.payStudent')
     icon = 'actionicon_pay.png'
-    text = _('Pay via Etranzact')
+    text = _('Pay via Etranzact WebConnect')
     target = 'goto_etranzact'
 
@@ -70,5 +70,5 @@
     grok.require('waeup.payStudent')
     icon = 'actionicon_call.png'
-    text = _('Requery Etranzact History')
+    text = _('Requery Etranzact WebConnect History')
     target = 'requery_history'
 
@@ -78,5 +78,5 @@
             self.context.student.current_session, self.context):
             return ''
-        if self.context.p_state in ('paid', 'waived'):
+        if self.context.p_state in ('paid', 'waived', 'scholarship'):
             return ''
         return self.view.url(self.view.context, self.target)
@@ -194,5 +194,5 @@
             self.context.student.current_session, self.context):
             return
-        if self.context.p_state in ('paid', 'waived'):
+        if self.context.p_state in ('paid', 'waived', 'scholarship'):
             self.flash(_('This ticket has already been paid.'), type='danger')
             return
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/browser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/browser.py	(revision 15795)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/browser.py	(revision 15796)
@@ -62,4 +62,11 @@
     grok.context(INigeriaStudentOnlinePayment)
 
+    @property
+    def target_url(self):
+        if not self.context.r_company:
+            return ''
+        return self.view.url(self.view.context, self.target)
+
+
 class NigeriaStudentBaseDisplayFormPage(StudentBaseDisplayFormPage):
     """ Page to display student base data
@@ -221,4 +228,10 @@
         'adm_code', 'sex', 'email', 'date_of_birth', 'current_level',
         'flash_notice')
+
+    def update(self):
+        if not self.context.r_company:
+            self.redirect(self.url(self.context))
+            return
+        return
 
 class NigeriaAccommodationManageFormPage(AccommodationManageFormPage):