Index: main/waeup.kofa/trunk/CHANGES.txt
===================================================================
--- main/waeup.kofa/trunk/CHANGES.txt	(revision 15811)
+++ main/waeup.kofa/trunk/CHANGES.txt	(revision 15818)
@@ -4,4 +4,7 @@
 1.6.1.dev0 (unreleased)
 =======================
+
+* Redirect to `ChangePasswordRequestPage` after successfully
+  adding an officer.
 
 * Add get_bursary_data webservice.
Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/pages.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/pages.py	(revision 15811)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/pages.py	(revision 15818)
@@ -62,5 +62,5 @@
     IPasswordValidator, IContactForm, IKofaUtils, ICSVExporter,
     academic_sessions_vocab, DOCLINK, registration_states_vocab,
-    TRANSREQ, TRANSVAL)
+    TRANSREQ, TRANSVAL, NotAnEmailAddress)
 from waeup.kofa.university.faculty import Faculty
 from waeup.kofa.university.department import Department
@@ -915,5 +915,8 @@
                                   'in the database.', type='danger')
             return
-        self.redirect(self.url(self.context))
+        #self.redirect(self.url(self.context))
+        args = {'identifier':name, 'email':email}
+        self.redirect(self.application_url() + '/changepw?%s' % urlencode(args))
+        return
 
 class UserManageFormPage(KofaEditFormPage):
@@ -2735,5 +2738,4 @@
     grok.require('waeup.Anonymous')
     grok.template('changepw')
-    label = _('Send me a new password')
     form_fields = grok.AutoFields(IChangePassword)
 
@@ -2750,5 +2752,26 @@
         self.captcha_result = self.captcha.verify(self.request)
         self.captcha_code = self.captcha.display(self.captcha_result.error_code)
-        return
+        # Unset default values maybe set by another person who used this form.
+        self.form_fields.get('identifier').field.default = None
+        self.form_fields.get('email').field.default = None
+        self.auto_fill = False
+        # If the form is used with url encoded form parameters.
+        form = self.request.form
+        if form.get('identifier') and form.get('email'):
+            try:
+                self.form_fields.get('identifier').field.default = form.get('identifier')
+                self.form_fields.get('email').field.default = str(form.get('email'))
+            except NotAnEmailAddress:
+                self.flash(_('This is not a valid email address.'),
+                       type='danger')
+                self.redirect(self.url(self.context))
+                return
+            self.auto_fill = True
+        return
+
+    def label(self):
+        if self.auto_fill:
+            return _('Send user a new password')
+        return _('Send me a new password')
 
     def _searchUser(self, identifier, email):
Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/templates/changepw.pt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/templates/changepw.pt	(revision 15811)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/templates/changepw.pt	(revision 15818)
@@ -8,5 +8,6 @@
   </table>
   <br />
-  <p i18n:translate="email_address_problem">
+  <p tal:condition="not: view/auto_fill"
+     i18n:translate="email_address_problem">
     Enter the email address stored in Kofa.
     You can't change your email address here.
Index: main/waeup.kofa/trunk/src/waeup/kofa/doctests/pages.txt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/doctests/pages.txt	(revision 15811)
+++ main/waeup.kofa/trunk/src/waeup/kofa/doctests/pages.txt	(revision 15818)
@@ -180,11 +180,15 @@
   >>> browser.getControl(name="control_password").value = 'TOP4secret'
   >>> browser.getControl("Add officer").click()
-  >>> print browser.contents
-  <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"...
-  ...<td>bob</td>
+
+We have been redirected to the Send Password page:
+
+  >>> print browser.contents
+  <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"...
+  ...Send user a new password...
   ...
 
 We can edit user bob:
 
+  >>> browser.open('http://localhost/myuniversity/users')
   >>> browser.getControl("Manage", index=0).click()
   >>> browser.getControl("Save", index=0).click()