Index: main/waeup.uniben/trunk/src/waeup/uniben/interswitch/browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/interswitch/browser.py	(revision 15827)
+++ main/waeup.uniben/trunk/src/waeup/uniben/interswitch/browser.py	(revision 15828)
@@ -73,4 +73,5 @@
             self.redirect(self.url(self.context, '@@index'))
             return
+        self.context.r_company = u'interswitch'
         student = self.student
         xmldict = self.xmldict
@@ -135,4 +136,5 @@
         self.context.provider_amt = provider_amt
         self.context.gateway_amt = GATEWAY_AMT
+        self.amount_auth = int(100 * self.context.amount_auth)
         return
 
@@ -154,4 +156,5 @@
             self.redirect(self.url(self.context, '@@index'))
             return
+        self.context.r_company = u'interswitch'
         xmldict = {}
         provider_amt = 400.0
@@ -184,4 +187,5 @@
         self.context.provider_amt = provider_amt
         self.context.gateway_amt = GATEWAY_AMT
+        self.amount_auth = int(100 * self.context.amount_auth)
         return
 
Index: main/waeup.uniben/trunk/src/waeup/uniben/remita/browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/remita/browser.py	(revision 15827)
+++ main/waeup.uniben/trunk/src/waeup/uniben/remita/browser.py	(revision 15828)
@@ -185,5 +185,6 @@
 
     def update(self):
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return
         self.orderId = self.context.p_id
@@ -279,5 +280,6 @@
 
     def update(self):
-        if not module_activated(self.context.__parent__.__parent__.year):
+        if not module_activated(
+            self.context.__parent__.__parent__.year, self.context):
             return
         self.orderId = self.context.p_id
Index: main/waeup.uniben/trunk/src/waeup/uniben/students/tests/test_browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/students/tests/test_browser.py	(revision 15827)
+++ main/waeup.uniben/trunk/src/waeup/uniben/students/tests/test_browser.py	(revision 15828)
@@ -321,8 +321,7 @@
         self.assertMatches('...Amount Authorized...',
                            self.browser.contents)
-        # Managers can open payment slip
-        self.browser.getLink("Download payment slip").click()
-        self.assertEqual(self.browser.headers['Status'], '200 Ok')
-        self.assertEqual(self.browser.headers['Content-Type'], 'application/pdf')
+        # Managers can open payment slip because we did not proceed to
+        # any payment gateway
+        self.assertFalse('Download payment slip' in self.browser.contents)
         # Set ticket paid
         ticket = self.student['payments'].items()[0][1]
Index: main/waeup.uniben/trunk/src/waeup/uniben/students/tests/test_export.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/students/tests/test_export.py	(revision 15827)
+++ main/waeup.uniben/trunk/src/waeup/uniben/students/tests/test_export.py	(revision 15828)
@@ -103,10 +103,10 @@
         result = open(self.outfile, 'rb').read()
         self.assertMatches(
-            'ac,amount_auth,creation_date,gateway_amt,p_category,p_combi,p_current,'
+            'ac,amount_auth,creation_date,gateway_amt,net_amt,p_category,p_combi,p_current,'
             'p_id,p_item,p_level,p_session,p_state,payment_date,provider_amt,'
             'r_amount_approved,r_card_num,r_code,r_company,r_desc,'
             'r_pay_reference,rebate_amount,staff_rebate,thirdparty_amt,student_id,state,'
             'current_session\r\n'
-            '666,12.12,%s-04-01 13:12:01#,,schoolfee,[],1,my-id,p-item,'
+            '666,12.12,%s-04-01 13:12:01#,,,schoolfee,[],1,my-id,p-item,'
             '100,%s,paid,%s-04-01 14:12:01#,,12.12,'
             '789,r-code,interswatch,,,,,,A111111,created,2012\r\n'